% Inverse Iteration mit Verschiebung bestimmt
% Eigenwert nahe s und entspr. Eigenvektor
% SS 2014 CB

A= [ 8 1 6          % Beispielmatrix, siehe auch Rechenbeispiel zum
    3 5 7          % char. Polynom im Skriptum (Seite 50 Ausgabe 2014)
    4 9 2 ];

n=length(A);
x=rand(n,1);        % zufaelliger Startvektor
s= -4;              % suche Eigenwert, der am naechsten bei s liegt
i = 3;              % mit i-ter Komponente wird skaliert.

eps=1e-8;
for k=1:100
    y = (A - s*eye(n))\x;
    x_neu = y/y(i);
    if(norm(x-x_neu)<eps)
        break;
    end
    x = x_neu;
end

% Ergebnis muss noch auf Eigenwert der
% Original-Matrix rueckgerechnet werden:
lambda = 1/y(i)+s  % der Eigenwert nahe bei s
x                 % der Eigenvektor
